.PRC_ID_KERNEL   equ 95   ;kernel proces
.PRC_ID_DESKTOP  equ 2   ;desktop manager process
.PRC_ID_SYSTEM   equ 3   ;system manager process
.MSC_GEN_QUIT    equ 0   ;application is beeing asked, to quit itself
.MSC_GEN_FOCUS   equ 255 ;application is beeing asked, to focus its window
.MSC_KRL_MTADDP  equ 1   ;add process (P1/2=stack, P3=priority (7 high - 1 low), P4=ram bank (0-8))
.MSC_KRL_MTDELP  equ 2   ;delete process (P1=ID)
.MSC_KRL_MTADDT  equ 3   ;add timer (P1/2=stack, P4=ram bank (0-8))
.MSC_KRL_MTDELT  equ 4   ;delete timer (P1=ID)
.MSC_KRL_MTSLPP  equ 5   ;set process to sleep mode
.MSC_KRL_MTWAKP  equ 6   ;wake up process
.MSC_KRL_TMADDT  equ 7   ;add counter service (P1/2=address, P3=ram bank, P4=process, P5=frequency)
.MSC_KRL_TMDELT  equ 8   ;delete counter service (P1/2=address, P3=ram bank)
.MSC_KRL_TMDELP  equ 9   ;delete all counter services of one process (P1=process ID)
.MSR_KRL_MTADDP  equ 129 ;process has been added (P1=0/1->ok/failed, P2=ID)
.MSR_KRL_MTDELP  equ 130 ;process has been deleted
.MSR_KRL_MTADDT  equ 131 ;timer process has been deleted (P1=0/1->ok/failed, P2=ID)
.MSR_KRL_MTDELT  equ 132 ;timer has been removed
.MSR_KRL_MTSLPP  equ 133 ;process is sleeping now
.MSR_KRL_MTWAKP  equ 134 ;process has been waked up
.MSR_KRL_TMADDT  equ 135 ;counter service has been added (P1=0/1->ok/failed)
.MSR_KRL_TMDELT  equ 136 ;counter service has been deleted
.MSR_KRL_TMDELP  equ 137 ;all counter services of a process have been deleted
.MSC_SYS_PRGRUN  equ 16  ;load application or document (P1/2=address filename, P3=ram bank filename)
.MSC_SYS_PRGEND  equ 17  ;quit application (P1=ID)
.MSC_SYS_SYSWNX  equ 18  ;open dialogue to change current window (next) (-)
.MSC_SYS_SYSWPR  equ 19  ;open dialogue to change current window (previouse) (vorheriges) (-)
.MSC_SYS_PRGSTA  equ 20  ;open dialogue to load application or document (-)
.MSC_SYS_SYSSEC  equ 21  ;open system secuity dialogue (-)
.MSC_SYS_SYSQIT  equ 22  ;open shut shown dialogue (-)
.MSC_SYS_SYSOFF  equ 23  ;shut down (-)
.MSC_SYS_PRGSET  equ 24  ;start control panel (P1=submodul -> 0=main window, 1=display settings, 2=date/time)
.MSC_SYS_PRGTSK  equ 25  ;start taskmanager (-)
.MSC_SYS_SYSFIL  equ 26  ;call filemanager function (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
.MSC_SYS_SYSHLP  equ 27  ;start help (-)
.MSC_SYS_SYSCFG  equ 28  ;call config function (P1=number, 0=load, 1=save, 2=reload background)
.MSC_SYS_SYSWRN  equ 29  ;open message/confirm window (P1/2=adresse, P3=ram bank, P4=number of buttons)
.MSC_SYS_PRGSRV  equ 30  ;shared service function (P4=type [0=search, 1=start, 2=release], P1/2=addresse 12char ID, P3=ram bank 12char ID or P3=program ID, if type=2)
.MSC_SYS_SELOPN  equ 31  ;open fileselect dialogue (P6=filename ram bank, P8/9=filename address, P7=forbidden attributes, P10=max entries, P12=max buffer size)
.MSR_SYS_PRGRUN  equ 144 ;application has been started (P1=result -> 0=ok, 1=file doesnt exist, 2=file is not executable, 3=error while loading  [P8=filemanager error code], 4=memory full, P8=app ID, P9=process ID)
.MSR_SYS_SYSFIL  equ 154 ;filemanager function returned (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
.MSR_SYS_SYSWRN  equ 157 ;message/confirm window response (P1 -> 0=already in use, 1=opened [P2=number], 2=ok, 3=yes, 4=no, 5=cancel/close)
.MSR_SYS_PRGSRV  equ 158 ;shared service function response (P1=state [5=not found, other codes see MSR_SYS_PRGRUN], P8=app ID, P9=process ID)
.MSR_SYS_SELOPN  equ 159 ;message from fileselect dialogue (P1 -> 0=Ok, 1=cancel, 2=already in use, 3=no memory free, 4=no window free, -1=open ok, modal window has been opened [P2=number])
.MSC_DSK_WINOPN  equ 32  ;open window (P1=ram bank, P2/3=address data record)
.MSC_DSK_WINMEN  equ 33  ;redraw menu bar (P1=window ID) [only if focus]
.MSC_DSK_WININH  equ 34  ;redraw window content (P1=window ID, P2=-1/-Num/Object, P3=Object) [only if focus]
.MSC_DSK_WINTOL  equ 35  ;redraw window toolbar (P1=window ID) [only if focus]
.MSC_DSK_WINTIT  equ 36  ;redraw window title (P1=window ID) [only if focus]
.MSC_DSK_WINSTA  equ 37  ;redraw window status lien (P1=window ID) [only if focus]
.MSC_DSK_WINMVX  equ 38  ;set content x offset (P1=window ID, P2/3=XPos) [only if focus]
.MSC_DSK_WINMVY  equ 39  ;set content y offset (P1=window ID, P2/3=XPos) [only if focus]
.MSC_DSK_WINTOP  equ 40  ;takes window to the front (P1=window ID) [always]
.MSC_DSK_WINMAX  equ 41  ;maximize window (P1=window ID) [always]
.MSC_DSK_WINMIN  equ 42  ;minimize window (P1=window ID) [always]
.MSC_DSK_WINMID  equ 43  ;restore window size (P1=window ID) [always]
.MSC_DSK_WINMOV  equ 44  ;moves window to a new position (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
.MSC_DSK_WINSIZ  equ 45  ;resize the window (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
.MSC_DSK_WINCLS  equ 46  ;closes and removes window (P1=window ID) [always]
.MSC_DSK_WINDIN  equ 47  ;redraw window content, even if it hasnt focus (P1=window ID, P2=-1/-Num/Objekt, P3=Object) [always]
.MSC_DSK_DSKSRV  equ 48  ;desktop service request (P1=type, P2-P5=parameters)
.MSC_DSK_WINSLD  equ 49  ;redraw window scrollbars (P1=window ID) [only if focus]
.MSC_DSK_WINPIN  equ 50  ;redraw window content part (P1=window ID, P2=-1/-Num/Object, P3=Object, P4/5=Xbeg, P6/7=Ybeg, P8/9=Xlen, P10/11=Ylen) [always]
.MSC_DSK_WINSIN  equ 51  ;redraw content of a super control (P1=window ID, P2=super control ID, P3=SubObject) [always]
.MSC_DSK_MENCTX  equ 52  ;opens context menu (P1=ram bank, P2/3=address data record, P4/5=Xbeg [-1=mouse position], P6/7=Ybeg) ##!!## doc+lib
.MSC_DSK_STIADD  equ 53  ;adds systray-icon (P1=ram bank, P2/3=address, P4=ID)
.MSC_DSK_STIREM  equ 54  ;removes systray-icon (P1=number)
.MSC_DSK_STIUPD  equ 55  ;updates systray-icon (P1=number)
.MSR_DSK_WOPNER  equ 160 ;open window failed; the maximum of 32 windows has been reached
.MSR_DSK_WOPNOK  equ 161 ;open window successfull (P4=number)
.MSR_DSK_WCLICK  equ 162 ;window has been clicked (P1=window number, P2=action, P3=subspezification, P4/5,P6/7,P8/9=parameters)
.MSR_DSK_DSKSRV  equ 163 ;desktop service answer (P1=type, P2-P5=parameters)
.MSR_DSK_WFOCUS  equ 164 ;window got/lost focus (P1=window number, P2=type [0=blur, 1=focus])
.MSR_DSK_CFOCUS  equ 165 ;control focus changed (P1=window number, P2=control number, P3=reason [0=mouse click/wheel, 1=tab key])
.MSR_DSK_WRESIZ  equ 166 ;window has been resized (P1=window number)
.MSR_DSK_WSCROL  equ 167 ;window content has been scrolled (P1=window number)
.MSR_DSK_MENCTX  equ 168 ;menu has been clicked or canceld (P1=1 ok, P2/3=value, P4=type [0=normal, 1=check]) ##!!## doc+lib
.MSR_DSK_STIADD  equ 169 ;result of adding systray-icon (P1=1 ok, P2=number)
.MSR_DSK_STICLK  equ 170 ;systray-icon has been clicked (P1=ID)
.MSR_DSK_EXTDSK  equ 191 ;command for extended desktop (used internally; P1=command, P2-x=parameters)
.FNC_DXT_DSKBGR  equ 001 ;background has been updated
.FNC_DXT_FILRUN  equ 002 ;file has been opened via prgrun (P2/3=address, P4=bank)
.FNC_DXT_FILBRW  equ 003 ;file has been selected via file browser (P2/3=address, P4=bank)
.FNC_DXT_MENCLK  equ 004 ;startmenu has been clicked (P2/3=value)
.FNC_DXT_DSKCLK  equ 005 ;desktop window has been clicked (P2=action, P3=subspezification, P4/5,P6/7,P8/9=parameters)
.MSC_SHL_CHRINP  equ 64  ;char is requested (P1=channel [0=standard, 1=keyboard])
.MSC_SHL_STRINP  equ 65  ;line is requested (P1=channel [0=standard, 1=keyboard], P2=ram bank, P3/4=address)
.MSC_SHL_CHROUT  equ 66  ;char should be writtten (P1=channel [0=standard, 1=screen], P2=char)
.MSC_SHL_STROUT  equ 67  ;line should be writtten (P1=channel [0=standard, 1=screen], P2=ram bank, P3/4=address, P5=length)
.MSC_SHL_EXIT    equ 68  ;application released focus or quit itself (P1 -> 0=quit, 1=blur)
.MSC_SHL_PTHADD  equ 69  ;add additional path to current one (P1=base path, P3=addition path, P5=final path, P7=ram bank)
.MSR_SHL_CHRINP  equ 192 ;char has been received (P1=EOF-flag [0=no EOF], P2=char, P3=error status)
.MSR_SHL_STRINP  equ 193 ;line has been received (P1=EOF-flag [0=no EOF], P3=error status)
.MSR_SHL_CHROUT  equ 194 ;char has been written (P3=error status)
.MSR_SHL_STROUT  equ 195 ;line has been written (P3=error status)
.MSR_SHL_PTHADD  equ 197 ;path has been combined (P1=total end address, P3=directory end address, P5=flags)
.MSC_SAV_INIT    equ 1   ;initialises the screen saver (P1=bank of config data, P2/3=address of config data [64bytes])
.MSC_SAV_START   equ 2   ;start screen saver
.MSC_SAV_CONFIG  equ 3   ;open screen savers own config window (at the end the screen saver has to send the result back to the sender)
.MSR_SAV_CONFIG  equ 4   ;returns user adjusted screen saver config data (P1=bank of config data, P2/3=address of config data [64bytes])
.DSK_ACT_CLOSE   equ 5   ;close button has been clicked or ALT+F4 has been pressed
.DSK_ACT_MENU    equ 6   ;menu entry has been clicked (P8/9=menu entry value)
.DSK_ACT_CONTENT equ 14  ;a control of the content has been clicked (P3=sub spec [see dsk_sub...], P4=key or P4/5=Xpos within the window, P6/7=Ypos, P8/9=control value)
.DSK_ACT_TOOLBAR equ 15  ;a control of the toolbar has been clicked (see DSK_ACT_CONTENT)
.DSK_ACT_KEY     equ 16  ;key has been pressed without touching/modifying a control (P4=Ascii Code)
.DSK_SUB_MLCLICK equ 0   ;left mouse button has been clicked
.DSK_SUB_MRCLICK equ 1   ;right mouse button has been clicked
.DSK_SUB_MDCLICK equ 2   ;double click with the left mouse button
.DSK_SUB_MMCLICK equ 3   ;middle mouse button has been clicked
.DSK_SUB_KEY     equ 7   ;keyboard has been clicked and did modify/click a control (P4=Ascii Code)
.DSK_SUB_MWHEEL  equ 8   ;mouse wheel has been moved (P4=Offset)
.DSK_SRV_MODGET  equ 1   ;get screen mode (output P2=mode, P3=virtual desktop)
.DSK_SRV_MODSET  equ 2   ;set screen mode (input P2=mode, P3=virtual desktop)
.DSK_SRV_COLGET  equ 3   ;get colour      (input P2=number, output P2=number, P3/4=RGB value)
.DSK_SRV_COLSET  equ 4   ;set colour      (input P2=number, P3/4=RGB value)
.DSK_SRV_DSKSTP  equ 5   ;freeze desktop  (input P2=type [0=Pen0, 1=Raster, 2=background, 255=no screen modification, switch off mouse])
.DSK_SRV_DSKCNT  equ 6   ;continue desktop
.DSK_SRV_DSKPNT  equ 7   ;clear desktop   (Eingabe P2=Typ [0=Pen0, 1=Raster, 2=background])
.DSK_SRV_DSKBGR  equ 8   ;initialize and redraw desktop background
.DSK_SRV_DSKPLT  equ 9   ;redraw the complete desktop
.DSK_SRV_DSKOPN  equ 11  ;open desktop background window
.CLPTYP_TEXT     equ 1   ;plain text
.CLPTYP_GRAPHIC  equ 2   ;graphic with extended header
.CLPTYP_ITEMS    equ 3   ;item list (*not defined yet*)
.CLPTYP_ICON     equ 4   ;desktop icon shortcut
.jmp_memsum  equ #8100 ;MEMSUM
.jmp_sysinf  equ #8103 ;SYSINF
.jmp_clcnum  equ #8106 ;CLCNUM
.jmp_mtgcnt  equ #8109 ;MTGCNT
.jmp_timget  equ #810C ;TIMGET
.jmp_timset  equ #810F ;TIMSET
.jmp_memget  equ #8118 ;MEMGET
.jmp_memfre  equ #811B ;MEMFRE
.jmp_memsiz  equ #811E ;MEMSIZ
.jmp_meminf  equ #8121 ;MEMINF
.jmp_bnkrwd  equ #8124 ;BNKRWD
.jmp_bnkwwd  equ #8127 ;BNKWWD
.jmp_bnkrbt  equ #812A ;BNKRBT
.jmp_bnkwbt  equ #812D ;BNKWBT
.jmp_bnkcop  equ #8130 ;BNKCOP
.jmp_bnkget  equ #8133 ;BNKGET
.jmp_scrget  equ #8139 ;SCRGET
.jmp_mosget  equ #813C ;MOSGET
.jmp_moskey  equ #813F ;MOSKEY
.jmp_bnk16c  equ #8142 ;BNK16C
.jmp_keytst  equ #8145 ;KEYTST
.jmp_keysta  equ #8148 ;KEYSTA
.jmp_keyput  equ #814B ;KEYPUT
.jmp_bufput  equ #814E ;BUFPUT
.jmp_bufget  equ #8151 ;BUFGET
.jmp_bufsta  equ #8154 ;BUFSTA
.jmp_iominp  equ #8157 ;IOMINP (cpc only)
.jmp_iomout  equ #815a ;IOMOUT (cpc only)
.jmp_bnkcll  equ #ff03 ;BNKCLL
.jmp_bnkret  equ #ff00 ;BNKRET
.FNC_FIL_STOINI  equ 000 ;Storage Init (Removes all mass storage devices)
.FNC_FIL_STONEW  equ 001 ;Storage New (Adds a new mass storage device)
.FNC_FIL_STORLD  equ 002 ;Storage Reload (Reloads a mass storage device, if its "removeable media" status is activated)
.FNC_FIL_STODEL  equ 003 ;Storage Delete (Removes an existing mass storage device)
.FNC_FIL_STOINP  equ 004 ;Storage ReadSector (Reads a sector from a mass storage device (no memory banking))
.FNC_FIL_STOOUT  equ 005 ;Storage WriteSector (Write a sector to a mass storage device (no memory banking))
.FNC_FIL_STOACT  equ 006 ;Storage Activate (Loads the format and the file system type of a mass storage device)
.FNC_FIL_STOINF  equ 007 ;Storage Information (Returns information about a mass storage device)
.FNC_FIL_STOTRN  equ 008 ;Storage DataTransfer (Reads or writes a number of sectors (512 bytes) from/to the mass storage device)
.FNC_FIL_DEVDIR  equ 013 ;
.FNC_FIL_DEVINI  equ 014 ;
.FNC_FIL_DEVSET  equ 015 ;
.FNC_FIL_FILINI  equ 016 ;File Init (Initialises the whole file manager)
.FNC_FIL_FILNEW  equ 017 ;File New (Creates a new file and opens it for read/write access)
.FNC_FIL_FILOPN  equ 018 ;File Open (Opens an existing file for read/write access)
.FNC_FIL_FILCLO  equ 019 ;File Close (Closes an opened file)
.FNC_FIL_FILINP  equ 020 ;File Input (Reads a specified amount of bytes out of an opened file)
.FNC_FIL_FILOUT  equ 021 ;File Output (Writes a specified amount of bytes into an opened file)
.FNC_FIL_FILPOI  equ 022 ;File Pointer (Moves the file pointer to another position)
.FNC_FIL_FILF2T  equ 023 ;File Decode Timestamp (Decodes the file timestamp, which is used for the file system)
.FNC_FIL_FILT2F  equ 024 ;File Encode Timestamp (Encodes the file timestamp, which is used for the file system)
.FNC_FIL_FILLIN  equ 025 ;File LineInput (Reads one text line out of an opened file)
.FNC_FIL_DIRDEV  equ 032 ;Directory Device (Selects the current drive)
.FNC_FIL_DIRPTH  equ 033 ;Directory Path (Selects the current path for the current or a different drive)
.FNC_FIL_DIRPRS  equ 034 ;Directory Property Set (Changes a property of a file or a directory)
.FNC_FIL_DIRPRR  equ 035 ;Directory Property Get (Reads a property of a file or a directory)
.FNC_FIL_DIRREN  equ 036 ;Directory Rename (Renames a file or a directory)
.FNC_FIL_DIRNEW  equ 037 ;Directory New (Creates a new directory)
.FNC_FIL_DIRINP  equ 038 ;Directory Input (Reads the content of a directory)
.FNC_FIL_DIRDEL  equ 039 ;Directory Delete (Deletes one or more files)
.FNC_FIL_DIRRMD  equ 040 ;Directory Delete Directory (Deletes a sub directory)
.FNC_FIL_DIRMOV  equ 041 ;Directory Move (Moves a file or sub directory into another directory of the same drive)
.FNC_FIL_DIRINF  equ 042 ;Directory Drive Information (Returns information about one drive)
.FNC_NET_CFGGET  equ 001 ;config information
.FNC_NET_CFGSET  equ 002 ;config setting
.FNC_NET_TCPOPN  equ 016 ;TCP open
.FNC_NET_TCPCLO  equ 017 ;TCP close
.FNC_NET_TCPSTA  equ 018 ;TCP status
.FNC_NET_TCPRCV  equ 019 ;TCP receive
.FNC_NET_TCPSND  equ 020 ;TCP send
.FNC_NET_TCPSKP  equ 021 ;TCP skip received data
.FNC_NET_TCPFLS  equ 022 ;TCP flush send buffer
.FNC_NET_TCPDIS  equ 023 ;TCP disconnect
.MSR_NET_TCPEVT  equ 159 ;TCP event
.FNC_NET_UDPOPN  equ 032 ;UDP open
.FNC_NET_UDPCLO  equ 033 ;UDP close
.FNC_NET_UDPSTA  equ 034 ;UDP status
.FNC_NET_UDPRCV  equ 035 ;UDP receive
.FNC_NET_UDPSND  equ 036 ;UDP send
.FNC_NET_UDPSKP  equ 037 ;UDP skip received data
.MSR_NET_UDPEVT  equ 175 ;UDP event
.FNC_NET_DNSRSV  equ 112 ;DNS resolve
.FNC_NET_DNSVFY  equ 113 ;DNS verify
.PrgDatCod     equ 0	;Code Length including 256 Header
.PrgDatDat     equ 2	;Data Length to a maximum 16k
.PrgDatTra     equ 4   ;Transfer Part Length
.PrgDatOrg     equ 6   ;Original ORG
.PrgDatRel     equ 8   ;Number of Entries in Relocation Table
.PrgDatStk     equ 10  ;Stack Length at start of Transfer
.PrgDatCrn     equ 12	;Crunched Length
.PrgDatCtp     equ 14	;Crunch Typ
.PrgDatNam     equ 15	;Program Name (Always 32 Bytes)+0 33 Byte
.PrgDatIdn     equ 48  ;SymExe10
.PrgDatRes     equ 62  ;Reserve
.PrgDatIsm     equ 90  ;Small Ico
.PrgDatIbg     equ 109 ;Big Ico
.PrgDatVer     equ 88  ;Version 3
.PrgDatLen     equ 256 ;
.PrgPstDat     equ 6   ;
.PrgPstTra     equ 8   ;
.PrgPstSpz     equ 10  ;
.PrgPstBnk     equ 14  ;
.PrgPstMem     equ 48  ;
.PrgPstNum     equ 88  ;
.PrgPstPrz     equ 89  ;
.ScanCode_E	equ 45
.g9k_VRAM				equ	#60				; R/W
.CG9K_VRAM				equ	#ff60			; R/W
.g9k_PALETTE			equ	#61				; R/W
.CG9K_PALETTE			equ	#ff61				; R/W
.g9k_CMD_DATA			equ	#62				; R/W
.g9k_REG_DATA			equ	#63				; R/W
.CG9K_REG_DATA			equ	#ff63				; R/W
.g9k_REG_SELECT			equ	#64				; W
.CG9K_REG_SELECT		equ	#ff64			; W
.CG9K_STATUS			equ	#ff65			; R
.g9k_INT_FLAG			equ	#66				; R/W
.g9k_SYS_CTRL			equ	#67				; W
.g9k_OUTPUT_CTRL		equ	#6F 		    ; R/W
.CG9K_OUTPUT_CTRL		equ	#ff6F 		    ; R/W
.g9k_SYS_CTRL_SRS		equ	2				; Power on reset state
.g9k_SYS_CTRL_MCKIN		equ	1				; Select MCKIN terminal
.g9k_SYS_CTRL_XTAL		equ	0				; Select XTAL
.g9k_WRITE_ADDR			equ	0				; W
.g9k_READ_ADDR			equ	3				; W
.g9k_SCREEN_MODE0		equ	6				; R/W
.g9k_SCREEN_MODE1		equ 7				; R/W
.g9k_CTRL				equ	8				; R/W
.g9k_INT_ENABLE         equ 9       		; R/W
.g9k_INT_V_LINE_LO		equ	10				; R/W	
.g9k_INT_V_LINE_HI		equ	11				; R/W
.g9k_INT_H_LINE			equ	12				; R/W	
.g9k_PALETTE_CTRL		equ	13				; W
.g9k_PALETTE_PTR		equ	14				; W
.g9k_BACK_DROP_COLOR 	equ 15		      	; R/W
.CG9K_BACK_DROP_COLOR 	equ 15		      	; R/W
.g9k_DISPLAY_ADJUST		equ	16				; R/W
.g9k_SCROLL_LOW_Y		equ 17 			    ; R/W
.g9k_SCROLL_HIGH_Y		equ 18      		; R/W
.g9k_SCROLL_LOW_X		equ 19      		; R/W
.g9k_SCROLL_HIGH_X		equ 20      		; R/W
.g9k_SCROLL_LOW_Y_B		equ 21 				; R/W
.g9k_SCROLL_HIGH_Y_B	equ 22      		; R/W
.g9k_SCROLL_LOW_X_B		equ 23      		; R/W
.g9k_SCROLL_HIGH_X_B	equ 24      		; R/W
.g9k_PAT_GEN_TABLE   	equ 25      		; R/W
.g9k_LCD_CTRL        	equ 26      		; R/W
.g9k_PRIORITY_CTRL  	equ 27      		; R/W
.g9k_SPR_PAL_CTRL		equ	28				; W
.g9k_SC_X				equ	32				; W
.g9k_SC_Y				equ	34				; W
.g9k_DS_X				equ	36				; W
.g9k_DS_Y				equ	38				; W
.g9k_NX					equ	40				; W
.g9k_NY					equ	42				; W
.g9k_ARG				equ	44				; W
.g9k_LOP				equ	45				; W
.g9k_WRITE_MASK			equ	46				; W
.g9k_FC					equ	48				; W
.g9k_BC					equ	50				; W
.g9k_OPCODE				equ	52				; W
.g9k_DIS_INC_READ		equ	64
.g9k_DIS_INC_WRITE		equ	128
.g9k_SCR0_STANDBY		equ	192				; Stand by mode
.g9k_SCR0_BITMAP		equ	128				; Select Bit map mode
.g9k_SCR0_P2			equ	64				; Select P1 mode
.g9k_SCR0_P1			equ	0				; Select P1 mode
.g9k_SCR0_DTCLK			equ	32				; Master Dot clock not divided
.g9k_SCR0_DTCLK2		equ	16				; Master Dot clock divided by 2
.g9k_SCR0_DTCLK4		equ	0				; Master Dot clock divided by 4
.g9k_SCR0_XIM2048		equ	12				; Image size = 2048
.g9k_SCR0_XIM1024		equ	8				; Image size = 1024
.g9k_SCR0_XIM512		equ	4				; Image size = 512
.g9k_SCR0_XIM256		equ	0				; Image size = 256
.g9k_SCR0_16BIT			equ	3				; 16 bits/dot
.g9k_SCR0_8BIT			equ	2				; 8 bits/dot
.g9k_SCR0_4BIT			equ	1				; 4 bits/dot
.g9k_SCR0_2BIT			equ 0				; 2 bits/dot
.g9k_SCR1_C25M			equ	64				; Select 640*480 mode
.g9k_SCR1_SM1			equ	32				; Selection of 263 lines during non interlace , else 262
.g9k_SCR1_SM			equ	16				; Selection of horizontal frequency 1H=fsc/227.5
.g9k_SCR1_PAL			equ	8				; Select PAL, else NTSC
.g9k_SCR1_EO			equ	4				; Select of vertical resoltion of twice the non-interlace resolution
.g9k_SCR1_IL			equ	2				; Select Interlace
.g9k_SCR1_HSCN			equ	1				; Select High scan mode
.g9k_CTRL_DISP			equ	128				; Display VRAM
.g9k_CTRL_DIS_SPD		equ	64				; Disable display sprite (cursor)
.g9k_CTRL_YSE			equ	32				; /YS Enable
.g9k_CTRL_VWTE			equ	16				; VRAM Serial data bus control during digitization
.g9k_CTRL_VWM			equ	8				; VRAM write control during digitization
.g9k_CTRL_DMAE			equ	4				; Enable DMAQ output
.g9k_CTRL_VRAM512		equ	2				; VRAM=512KB
.g9k_CTRL_VRAM256		equ	1				; VRAM=256KB
.g9k_CTRL_VRAM128		equ	0				; VRAM=128KB
.g9k_INT_IECE	        equ 4       		; Command end interrupt enable control
.g9k_INT_IEH	        equ 2       		; Display position interrupt enable
.g9k_INT_IEV	        equ 1       		; Int. enable during vertical retrace line interval
.g9k_PAL_CTRL_YUV		equ	192				; YUV mode
.g9k_PAL_CTRL_YJK		equ	128				; YJK mode
.g9k_PAL_CTRL_256		equ	64				; 256 color mode
.g9k_PAL_CTRL_PAL		equ	0				; Pallete mode
.g9k_PAL_CTRL_YAE		equ	32				; Enable YUV/YJK RGB mixing mode
.g9k_LOP_TP				equ	16
.g9k_LOP_WCSC			equ	12
.g9k_LOP_WCNOTSC		equ	3
.g9k_LOP_WCANDSC		equ	8
.g9k_LOP_WCORSC			equ	14
.g9k_LOP_WCEORSC		equ	6
.g9k_ARG_MAJ			equ	1
.g9k_ARG_NEG			equ	2
.g9k_ARG_DIX			equ	4
.g9k_ARG_DIY			equ	8
.g9k_OPCODE_STOP		equ	#00				; Command being excuted is stopped 
.g9k_OPCODE_LMMC		equ	#10     		; Data is transferred from CPU to VRAM rectangle area
.g9k_OPCODE_LMMV		equ	#20     		; VRAM rectangle area is painted out
.g9k_OPCODE_LMCM		equ	#30				; VRAM rectangle area is transferred to CPU
.g9k_OPCODE_LMMM		equ	#40				; Rectangle area os transferred from VRAM to VRAM
.g9k_OPCODE_CMMC		equ	#050			; CPU character data is color-developed and transferred to VRAM rectangle area
.g9k_OPCODE_CMMK		equ	#060			; Kanji ROM data is is color-developed and transferred to VRAM rectangle area
.g9k_OPCODE_CMMM		equ	#070			; VRAM character data is color-developed and transferred to VRAM rectangle area 
.g9k_OPCODE_BMXL		equ	#080			; Data on VRAM linear address is transferred to VRAM rectangle area
.g9k_OPCODE_BMLX		equ	#090			; VRAM rectangle area is transferred to VRAM linear address 
.g9k_OPCODE_BMLL		equ	#0A0			; Data on VRAM linear address is transferred to VRAM linear address 
.g9k_OPCODE_LINE		equ	#0B0			; Straight line is drawer on X-Y co-ordinates
.g9k_OPCODE_SRCH		equ	#0C0			; Border color co-ordinates on X-Y are detected
.g9k_OPCODE_POINT		equ	#0D0			; Color code on specified point on X-Y is read out
.g9k_OPCODE_PSET		equ	#0E0			; Drawing is executed at drawing point on X-Y co-ordinates
.g9k_OPCODE_ADVN		equ	#0F0			; Drawing point on X-Y co-ordinates is shifted
.g9k_STATUS_TR          equ 128
.g9k_STATUS_VR          equ 64
.g9k_STATUS_HR          equ 32
.g9k_STATUS_BD          equ 16
.g9k_STATUS_MSC         equ 4
.g9k_STATUS_EO          equ 2
.g9k_STATUS_CE          equ 1
.g9k_MODE_P1			equ	0				; Pattern mode 0 256 212
.g9k_MODE_P2			equ	1				; Pattern mode 1 512 212
.g9k_MODE_B1			equ	2				; Bitmap mode 1 256 212
.g9k_MODE_B2			equ	3				; Bitmap mode 2 384 240
.g9k_MODE_B3			equ	4				; Bitmap mode 3 512 212
.g9k_MODE_B4			equ	5				; Bitmap mode 4 768 240
.g9k_MODE_B5			equ	6				; Bitmap mode 5 640 400 (VGA)
.g9k_MODE_B6			equ	7				; Bitmap mode 6 640 480 (VGA)
.g9k_MODE_B7			equ	8				; Bitmap mode 7 1024 212 (Undocumented v9990 mode)
.g9k_RED                 equ 32
.g9k_GREEN               equ 1024
.g9k_BLUE                equ 1
SYMBOS_ORG #100
.AppCodBeg     dw  AppDatBeg-AppCodBeg      ;Length of Cod
.AppDataSize   dw  AppTrnBeg-AppDatBeg      ;Length of Dat
.AppTrnSize    dw  AppTrnEnd-AppTrnBeg      ;Length of Transfe
.AppDatAdr     dw  #100                    ;Original Origi
.AppTrnAdr     dw  0                        ;Number of Entries In Relocation Tabl
.AppPrzLst     dw  AppStk-AppTrnBeg         ;Stack Lengt
               dw  0                        ;Length of Crunched Dat
.AppBnkNum     db  0                        ;Crunch Typ
.AppNam        db  "SymbOS Application      ",0
.AppIcon16     db  1
.AppIconOff    dw  Icon24_Data-AppCodBeg
.Appxxxx       db  0,0,0,0,0
.AppMemTab     db  "SymExe10"             ;File Check
.AppDataLen    equ  AppTrnBeg-AppDatBeg      ;Length of Data
.AppTrnLen     equ  AppTrnEnd-AppTrnBeg      ;Length of Transfer
.AppTrnLen2    equ  2000-AppTrnLen
.AppDataLen2    equ  2000-AppDataLen
.AppExtCode    dw  0
.AppExtData    dw  AppDataLen2
.AppExtTrans   dw  AppTrnLen2
               ds  28
.AppIcnSml    
.AppStartForm  equ 0
        db 2,8,8
      db     15,15,14,3,13,13,73,73,73,73,75,75,60,135,15,15
.AppIcnBig    
.AppIcnLrg       db 6,24,24
             db 255,255,255,255,255,255
             db 136,0,0,0,0,17
             db 136,0,16,224,0,17
             db 136,16,225,30,128,17
             db 136,33,15,15,104,17
             db 136,67,15,15,30,17
             db 136,135,30,135,30,17
             db 136,135,44,67,30,17
             db 152,15,72,33,30,17
             db 152,15,72,33,30,17
             db 152,15,72,33,30,17
             db 152,15,72,67,44,17
             db 152,15,60,135,44,17
             db 152,15,15,15,72,17
             db 136,135,15,15,192,17
             db 136,67,15,30,0,17
             db 136,48,195,15,128,17
             db 136,0,33,15,120,145
             db 136,0,16,15,15,145
             db 136,0,0,135,15,145
             db 136,0,0,67,15,145
             db 136,0,0,48,240,145
             db 136,0,0,0,0,17
             db 255,255,255,255,255,255
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3
.V_App_In_Use			db 	0
.AppPrz:
		ld		hl,AppTrnEnd+260
		ld		a,h
		ld		(Quig_String_AS_HByte),a		;Set Byte so we can check if string is in String area or String buffer
		ld 		a,DSK_SRV_MODGET
        call	SyDesktop_Service
		ld		(Quig_ModeUsed),de
		ld 		a,DSK_SRV_DSKSTP
		ld 		e,1
		call 	SyDesktop_Service
		call	Quig_G9K_SETMODE_50
		ld		a,g9k_PALETTE_PTR
		ld		bc,CG9K_REG_SELECT
		out 	(c),a
		xor		a
		ld		bc,CG9K_REG_DATA
		out		(c),a
		ld		bc,CG9K_OUTPUT_CTRL
        out  	(c),A    	   	; Set output GFX9000	
		call	Quig_g9k_ForeBack_Palette_Set
		call	qfunc_initialize
.Quig_Control_Loop:
		call	Quig_G9K_VWait
.Quig_Control_Loop_2:
		call	qfunc_main
.Quig_Control_Loop_1:
		jp		Quig_Control_Loop
.Quig_ModeUsed:	dw	0
.G9kInterrupt:
		di
		ei
		reti
.Quig_End:
		ld		de,(Quig_ModeUsed)
		ld		a,e
		or		%10000000
		ld		e,a
		ld 		a,DSK_SRV_MODSET
        call 	SyDesktop_Service
		ld 		a,DSK_SRV_DSKCNT
		call 	SyDesktop_Service
		ld 		a,DSK_SRV_DSKPLT
		call	SyDesktop_Service
		ld		a,(AppPrzN)
		db		#dd:ld l,a
		ld		a,(SysPrzN)
		db		#dd:ld h,a
		ld		a,(AppCodBeg+PrgPstNum)
		ld		h,a
		ld		l,MSC_SYS_PRGEND
		ld		(AppMsgB),hl
		ld		iy,AppMsgB
		rst		#10
.Quig_End_1
 		rst		#30
		jr		Quig_End_1
.SySystem_CallFunction
		ld (AppMsgB+04),bc      ;copy registers into the message buffer
        ld (AppMsgB+06),de
        ld (AppMsgB+08),hl
        ld (AppMsgB+10),ix
        ld (AppMsgB+12),iy
        push af
        pop hl
        ld (AppMsgB+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (AppMsgB+00),de      ;module und funktion number
        ld a,e
        ld (SyCallN),a
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #10                 ;send message
.SyCall1 rst #30
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #18                 ;wait for answer
        db #dd:dec l
        jr nz,SyCall1
        ld a,(AppMsgB)
        sub 128
        ld e,a
        ld a,(SyCallN)
        cp e
        jr nz,SyCall1
        ld hl,(AppMsgB+02)      ;get registers out of the message buffer
        push hl
        pop af
        ld bc,(AppMsgB+04)
        ld de,(AppMsgB+06)
        ld hl,(AppMsgB+08)
        ld ix,(AppMsgB+10)
        ld iy,(AppMsgB+12)
        ret
.SyCallN db 0		
.Quig_GetWindowEventAddr
		add		a				;Times 2
		add		a				;Times 4
		add		a				;Times 8
		add		c				;Event
		add		a				;Times 16 + (Event*2)
		ld		hl,App_Form_List
		ld		e,a
		ld		d,0
		add		hl,de
		ret
.Quig_Sprite_Attributes		
		ds		512		
.Quig_Form_No:				db	0
.Quig_FormIDs:				db  255,255,255,255,255,255,255,255
.Quig_Directory_Error_Byte:		db	0
.Quig_String_Buffer_Area_Start 	equ AppTrnEnd+260
.Quig_String_Buffer_Top			equ AppTrnEnd+260+AppTrnLen2
.Quig_String_Buffer_StackNo:	dw 0
.Quig_String_Buffer_Pos:		dw AppTrnEnd+260
.Quig_String_Buffer_Stack:		dw AppTrnEnd+260,0,0,0,0,0,0,0,0,0
.Quig_String_AS_HByte:			db 0
.Quig_String_Pos:				dw Quig_String_End_Text+4
.ErrorNum:					dw	0
.ErrorPC:					dw	0
.False:						db	0
.True:						db	1
.tcounter					dw	0
.QFunc_INITIALIZE
.QLn_24		;//pattCount=Fore.Pattern.Load(App.Path+"sheet1.qpt",0,0)
		call	Quig_App_Path		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,directstr_1+2		;//hl points static string [Qc055]
		call	Quig_Str_Add		;//Compare strings equals HL=DE [Qc057]
		push		hl 		;//Store result [Qc001]
		Ld 		de,0			;// Optimize -6- [Qc1040]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_TileALoad		;/ Call Function [Qc052]
		ld		(var_wrd_pattCount),hl		;//Int variable 'var_wrd_pattCount'=expression result [Qc219]
.QLn_26		;//VWait
		call	Quig_G9K_VWait				;//Call 'VWait' [Qc234]
.QLn_28		;//For f=0 To 32 Step 2
		ld		hl,32		;//hl=number '32' [Qc054]
		ld 		a,l 			;/Put result in a [Qc400]
		ld 		(QFr577_Top+1),a 			;/Copy Result into static'var_byt_f' [Qc401]
		ld		hl,0		;//hl=number '0' [Qc054]
		ld 		a,l 		;/Loop Repeat Point [Qc402]
		.QFr577_Loop:ld 		(var_byt_f),a ;/Loop Repeat Point [Qc403]
		and			a 					;//[Qc408]
		.QFr577_Top:sbc		a,0 		;//[Qc404]
		jp		c,QFr577_Start		;//[Qc405]
		jp		nz,QFr577_Exit		;//[Qc406]
.QFr577_Start:
.QLn_29		;//Meta.Int.Set f,0
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		ex		de,hl 		;// [Qc232]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_G9k_Meta_Int_Set				;//Call 'Meta.Int.Set' [Qc234]
.QLn_30		;//Next
		ld		a,(var_byt_f) ;// [Qc430]
		inc		a		;// [Qc433]
		inc		a 		;// [Qc434]
		jp		QFr577_Loop		;// [Qc440]
.QFr577_Exit:
.QLn_31		;//For f=0 To 32 Step 2
		ld		hl,32		;//hl=number '32' [Qc054]
		ld 		a,l 			;/Put result in a [Qc400]
		ld 		(QFr601_Top+1),a 			;/Copy Result into static'var_byt_f' [Qc401]
		ld		hl,0		;//hl=number '0' [Qc054]
		ld 		a,l 		;/Loop Repeat Point [Qc402]
		.QFr601_Loop:ld 		(var_byt_f),a ;/Loop Repeat Point [Qc403]
		and			a 					;//[Qc408]
		.QFr601_Top:sbc		a,0 		;//[Qc404]
		jp		c,QFr601_Start		;//[Qc405]
		jp		nz,QFr601_Exit		;//[Qc406]
.QFr601_Start:
.QLn_32		;//Meta.Int.Set f+32,10
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,32		;//hl=number '32' [Qc054]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc232]
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_G9k_Meta_Int_Set				;//Call 'Meta.Int.Set' [Qc234]
.QLn_33		;//Next
		ld		a,(var_byt_f) ;// [Qc430]
		inc		a		;// [Qc433]
		inc		a 		;// [Qc434]
		jp		QFr601_Loop		;// [Qc440]
.QFr601_Exit:
.QLn_34		;//For f=0 To 32 Step 2
		ld		hl,32		;//hl=number '32' [Qc054]
		ld 		a,l 			;/Put result in a [Qc400]
		ld 		(QFr628_Top+1),a 			;/Copy Result into static'var_byt_f' [Qc401]
		ld		hl,0		;//hl=number '0' [Qc054]
		ld 		a,l 		;/Loop Repeat Point [Qc402]
		.QFr628_Loop:ld 		(var_byt_f),a ;/Loop Repeat Point [Qc403]
		and			a 					;//[Qc408]
		.QFr628_Top:sbc		a,0 		;//[Qc404]
		jp		c,QFr628_Start		;//[Qc405]
		jp		nz,QFr628_Exit		;//[Qc406]
.QFr628_Start:
.QLn_35		;//Meta.Int.Set f+64,2
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,64		;//hl=number '64' [Qc054]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ex		de,hl 		;// [Qc232]
		ld		hl,2		;//hl=number '2' [Qc054]
		call	Quig_G9k_Meta_Int_Set				;//Call 'Meta.Int.Set' [Qc234]
.QLn_36		;//Next
		ld		a,(var_byt_f) ;// [Qc430]
		inc		a		;// [Qc433]
		inc		a 		;// [Qc434]
		jp		QFr628_Loop		;// [Qc440]
.QFr628_Exit:
.QLn_40		;//For f=0 To 15
		ld		hl,15		;//hl=number '15' [Qc054]
		ld 		a,l 			;/Put result in a [Qc400]
		ld 		(QFr655_Top+1),a 			;/Copy Result into static'var_byt_f' [Qc401]
		ld		hl,0		;//hl=number '0' [Qc054]
		ld 		a,l 		;/Loop Repeat Point [Qc402]
		.QFr655_Loop:ld 		(var_byt_f),a ;/Loop Repeat Point [Qc403]
		and			a 					;//[Qc408]
		.QFr655_Top:sbc		a,0 		;//[Qc404]
		jp		c,QFr655_Start		;//[Qc405]
		jp		nz,QFr655_Exit		;//[Qc406]
.QFr655_Start:
.QLn_41		;//For g=0 To 15
		ld		hl,15		;//hl=number '15' [Qc054]
		ld 		a,l 			;/Put result in a [Qc400]
		ld 		(QFr667_Top+1),a 			;/Copy Result into static'var_byt_g' [Qc401]
		ld		hl,0		;//hl=number '0' [Qc054]
		ld 		a,l 		;/Loop Repeat Point [Qc402]
		.QFr667_Loop:ld 		(var_byt_g),a ;/Loop Repeat Point [Qc403]
		and			a 					;//[Qc408]
		.QFr667_Top:sbc		a,0 		;//[Qc404]
		jp		c,QFr667_Start		;//[Qc405]
		jp		nz,QFr667_Exit		;//[Qc406]
.QFr667_Start:
.QLn_42		;//Fore.Map.Meta f,g,0
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,(var_byt_g)		;//l=value of 'var_byt_g' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		ex		de,hl 		;// [Qc232]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_G9k_MapA_Meta				;//Call 'Fore.Map.Meta' [Qc234]
.QLn_43		;//Next
		ld		a,(var_byt_g) ;// [Qc430]
		inc		a		;// [Qc431]
		jp		QFr667_Loop		;// [Qc440]
.QFr667_Exit:
.QLn_44		;//Next
		ld		a,(var_byt_f) ;// [Qc430]
		inc		a		;// [Qc431]
		jp		QFr655_Loop		;// [Qc440]
.QFr655_Exit:
.QLn_46		;//scrollxlast = Shr5(scrollx)
		ld		hl,(var_wrd_scrollx) 	;//hl=value of 'var_wrd_scrollx' [Qc053]
		call	Quig_Shr5		;/ Call Function [Qc052]
		ld		(var_wrd_scrollxlast),hl		;//Int variable 'var_wrd_scrollxlast'=expression result [Qc219]
.QLn_48		;//EndF
		ret		;// [Qc262]
.QLn_50		;//Function Main:Void()
.QFunc_MAIN
.QLn_53		;//Fore.Scroll scrollx,0
		ld		hl,(var_wrd_scrollx) 	;//hl=value of 'var_wrd_scrollx' [Qc053]
		ex		de,hl 		;// [Qc232]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_Scroll_A				;//Call 'Fore.Scroll' [Qc234]
.QLn_54		;//g=Mouse.Key()
		call	Quig_Mouse_Key		;/ Call Function [Qc052]
		ld		a,l		;//var_byt_g'=Expression [Qc212]
		ld		(var_byt_g),a		;//Copy Result into 'var_byt_g' [Qc213]
.QLn_55		;//If g=0 Then
		Ld		a,(var_byt_g)			;// Optimize 508 [Qc5040]
		cp		0					;// [Qc5041]
		jp		nz,QIf725_Exit			;// [Qc5042]
.QLn_56		;//scrollx=Min(scrollx+1,1024)
		ld		hl,(var_wrd_scrollx) 	;//hl=value of 'var_wrd_scrollx' [Qc053]
		inc		hl		;//Plus 1 [Qc090]
		ex		de,hl 		;// [Qc269]
		ld		hl,1024		;//hl=number '1024' [Qc054]
		call	Quig_Min_Int		;/ Call Function [Qc052]
		ld		(var_wrd_scrollx),hl		;//Int variable 'var_wrd_scrollx'=expression result [Qc219]
.QLn_57		;//EndIf
.QIf725_Exit:
.QLn_58		;//If g=1 Then
		Ld		a,(var_byt_g)			;// Optimize 508 [Qc5040]
		cp		1					;// [Qc5041]
		jp		nz,QIf748_Exit			;// [Qc5042]
.QLn_59		;//scrollx=Max(scrollx-1,0)
		ld		hl,(var_wrd_scrollx) 	;//hl=value of 'var_wrd_scrollx' [Qc053]
		dec		hl		;//Minus 1 [Qc093]
		ex		de,hl 		;// [Qc269]
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_Max_Int		;/ Call Function [Qc052]
		ld		(var_wrd_scrollx),hl		;//Int variable 'var_wrd_scrollx'=expression result [Qc219]
.QLn_60		;//EndIf
.QIf748_Exit:
.QLn_61		;//scrollxnow = Shr5(scrollx)
		ld		hl,(var_wrd_scrollx) 	;//hl=value of 'var_wrd_scrollx' [Qc053]
		call	Quig_Shr5		;/ Call Function [Qc052]
		ld		(var_wrd_scrollxnow),hl		;//Int variable 'var_wrd_scrollxnow'=expression result [Qc219]
.QLn_63		;//If scrollxnow<>scrollxlast Then
		ld		hl,(var_wrd_scrollxnow) 	;//hl=value of 'var_wrd_scrollxnow' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_scrollxlast) 	;//hl=value of 'var_wrd_scrollxlast' [Qc053]
		Xor 	a						;// Optimize -3b- [Qc1213]
		sbc		hl,de					;// [Qc1214]
		jp		z,QIf774_Exit				;// [Qc1215]
.QLn_65		;//If scrollxlast>scrollxnow Then
		ld		hl,(var_wrd_scrollxlast) 	;//hl=value of 'var_wrd_scrollxlast' [Qc053]
		ex		de,hl 		;// [Qc269]
		ld		hl,(var_wrd_scrollxnow) 	;//hl=value of 'var_wrd_scrollxnow' [Qc053]
		call 	Quig_GT_HL_Direct		;// Optimize -3d- [Qc1219]
		jp		z,QIf782_Exit				;// [Qc1220]
.QLn_66		;//f=scrollxnow-2
		ld		hl,(var_wrd_scrollxnow) 	;//hl=value of 'var_wrd_scrollxnow' [Qc053]
		dec		hl 			;** Integer x=x-2 [Qc094]
		dec		hl			;// [Qc095]
		ld		a,l		;//var_byt_f'=Expression [Qc212]
		ld		(var_byt_f),a		;//Copy Result into 'var_byt_f' [Qc213]
.QLn_67		;//Else
		jp		QIf782_Exit2		;//Jump to EndIf
.QIf782_Exit:
.QLn_68		;//f=scrollxnow+10
		Ld		hl,(var_wrd_scrollxnow)			;// Optimize -1a- [Qc1060]
		Ld		de,10			;// [Qc1061]
		add		hl,de		;//Add Integer HL & DE Values [Qc058]
		ld		a,l		;//var_byt_f'=Expression [Qc212]
		ld		(var_byt_f),a		;//Copy Result into 'var_byt_f' [Qc213]
.QLn_69		;//EndIf
.QIf782_Exit2:
.QLn_70		;//scrollxlast = scrollxnow
		ld		hl,(var_wrd_scrollxnow) 	;//hl=value of 'var_wrd_scrollxnow' [Qc053]
		ld		(var_wrd_scrollxlast),hl		;//Int variable 'var_wrd_scrollxlast'=expression result [Qc219]
.QLn_71		;//Randomize f*64
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,64		;//hl=number '64' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		call	Quig_IRandomize				;//Call 'Randomize' [Qc234]
.QLn_72		;//BackColour.Set 9
		ld		hl,9		;//hl=number '9' [Qc054]
		call	Quig_g9k_BackColour_Set				;//Call 'BackColour.Set' [Qc234]
.QLn_73		;//Fore.Map.Meta f,0,Rnd(3)*32
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,0		;//hl=number '0' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,3		;//hl=number '3' [Qc054]
		call	Quig_IRnd		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,32		;//hl=number '32' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_G9k_MapA_Meta				;//Call 'Fore.Map.Meta' [Qc234]
.QLn_74		;//BackColour.Set 10
		ld		hl,10		;//hl=number '10' [Qc054]
		call	Quig_g9k_BackColour_Set				;//Call 'BackColour.Set' [Qc234]
.QLn_75		;//Fore.Map.Meta f,1,Rnd(3)*32
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,1		;//hl=number '1' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,3		;//hl=number '3' [Qc054]
		call	Quig_IRnd		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,32		;//hl=number '32' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_G9k_MapA_Meta				;//Call 'Fore.Map.Meta' [Qc234]
.QLn_76		;//BackColour.Set 1
		ld		hl,1		;//hl=number '1' [Qc054]
		call	Quig_g9k_BackColour_Set				;//Call 'BackColour.Set' [Qc234]
.QLn_77		;//Fore.Map.Meta f,2,Rnd(3)*32
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,2		;//hl=number '2' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,3		;//hl=number '3' [Qc054]
		call	Quig_IRnd		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,32		;//hl=number '32' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_G9k_MapA_Meta				;//Call 'Fore.Map.Meta' [Qc234]
.QLn_78		;//BackColour.Set 3
		ld		hl,3		;//hl=number '3' [Qc054]
		call	Quig_g9k_BackColour_Set				;//Call 'BackColour.Set' [Qc234]
.QLn_79		;//Fore.Map.Meta f,3,Rnd(3)*32
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,3		;//hl=number '3' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,3		;//hl=number '3' [Qc054]
		call	Quig_IRnd		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,32		;//hl=number '32' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_G9k_MapA_Meta				;//Call 'Fore.Map.Meta' [Qc234]
.QLn_80		;//BackColour.Set 9
		ld		hl,9		;//hl=number '9' [Qc054]
		call	Quig_g9k_BackColour_Set				;//Call 'BackColour.Set' [Qc234]
.QLn_81		;//Fore.Map.Meta f,4,Rnd(3)*32
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,4		;//hl=number '4' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,3		;//hl=number '3' [Qc054]
		call	Quig_IRnd		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,32		;//hl=number '32' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_G9k_MapA_Meta				;//Call 'Fore.Map.Meta' [Qc234]
.QLn_82		;//BackColour.Set 8
		ld		hl,8		;//hl=number '8' [Qc054]
		call	Quig_g9k_BackColour_Set				;//Call 'BackColour.Set' [Qc234]
.QLn_83		;//Fore.Map.Meta f,5,Rnd(3)*32
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,5		;//hl=number '5' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,3		;//hl=number '3' [Qc054]
		call	Quig_IRnd		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,32		;//hl=number '32' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_G9k_MapA_Meta				;//Call 'Fore.Map.Meta' [Qc234]
.QLn_84		;//BackColour.Set 7
		ld		hl,7		;//hl=number '7' [Qc054]
		call	Quig_g9k_BackColour_Set				;//Call 'BackColour.Set' [Qc234]
.QLn_85		;//Fore.Map.Meta f,6,Rnd(3)*32
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,6		;//hl=number '6' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,3		;//hl=number '3' [Qc054]
		call	Quig_IRnd		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,32		;//hl=number '32' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_G9k_MapA_Meta				;//Call 'Fore.Map.Meta' [Qc234]
.QLn_86		;//BackColour.Set 6
		ld		hl,6		;//hl=number '6' [Qc054]
		call	Quig_g9k_BackColour_Set				;//Call 'BackColour.Set' [Qc234]
.QLn_87		;//Fore.Map.Meta f,7,Rnd(3)*32
		ld		hl,(var_byt_f)		;//l=value of 'var_byt_f' [Qc007]
		ld		h,0		;//h=0 [Qc052]
		push		hl		;// Store result [Qc225]
		ld		hl,7		;//hl=number '7' [Qc054]
		push		hl		;// Store result [Qc225]
		ld		hl,3		;//hl=number '3' [Qc054]
		call	Quig_IRnd		;/ Call Function [Qc052]
		ex		de,hl 		;// [Qc269]
		ld		hl,32		;//hl=number '32' [Qc054]
		call	Quig_Mul16		;/Multiply HL & DE [Qc064]
		pop		de		;//Restore value from stack [Qc233]
		call	Quig_G9k_MapA_Meta				;//Call 'Fore.Map.Meta' [Qc234]
.QLn_88		;//BackColour.Set 0
		ld		hl,0		;//hl=number '0' [Qc054]
		call	Quig_g9k_BackColour_Set				;//Call 'BackColour.Set' [Qc234]
.QLn_89		;//EndIf
.QIf774_Exit:
.QLn_90		;//If g=2 Then
		Ld		a,(var_byt_g)			;// Optimize 508 [Qc5040]
		cp		2					;// [Qc5041]
		jp		nz,QIf957_Exit			;// [Qc5042]
.QLn_91		;//App.Exit
		call	Quig_End				;//Call 'App.Exit' [Qc234]
.QLn_92		;//EndIf
.QIf957_Exit:
.QLn_94		;//EndF
		ret		;// [Qc262]
.QLn_97		;//ASM
.SyDesktop_Service:
		ld 		c,MSC_DSK_DSKSRV
        ld 		(SyDSrvN),a
        push 	af
        call 	SyDesktop_SendMessage
        pop 	af
        cp 		1
        jr 		z,SyDSrv1
        cp 		3
        jr 		z,SyDSrv1
        cp 		5
        ret 	nz
.SyDSrv1:
		call 	SyDesktop_WaitMessage
        cp 		MSR_DSK_DSKSRV
        jr 		nz,SyDSrv1
        ld 		a,(SyDSrvN)
        cp 		(iy+1)
        jr 		nz,SyDSrv1
        ld 		e,(iy+2)
        ld 		d,(iy+3)
        ld 		l,(iy+4)
        ld 		h,(iy+5)
        ret
.SyDSrvN db 0
.Quig_g9k_SetMode_50
		ld		a,0				;quit reset mode & select XTAL oscilator
		ld		bc,CG9K_VRAM+7
		out		(c),a
		ld		a,6				;set REGISTER 6,7,8 for P1 mode
		ld		bc,CG9K_VRAM+4
		out		(c),a
		ld		a,5				;reg #6
		ld		bc,CG9K_VRAM+3
		out		(c),a
		ld		a,8				;reg #7   +8 pour 50Hz
		out		(c),A
		ret		
.Quig_g9k_Fore_Palette_Set
		ld		a,l
		and		%11
		ld		l,a
		ld		a,(Quig_g9k_ForeBack_Palette)
		and		%1100
		or		l
		ld		(Quig_g9k_ForeBack_Palette),a
		jp		Quig_g9k_ForeBack_Palette_Set
.Quig_g9k_Back_Palette_Set
		ld		a,l
		rla
		rla	
		and		%1100
		ld		l,a
		ld		a,(Quig_g9k_ForeBack_Palette)
		and		%11
		or		l
		ld		(Quig_g9k_ForeBack_Palette),a
.Quig_g9k_ForeBack_Palette_Set
		ld		a,g9k_PALETTE_CTRL
		ld		bc,CG9K_REG_SELECT
		out 	(c),a
		ld		a,(Quig_g9k_ForeBack_Palette)
		ld		bc,CG9K_REG_DATA
		out		(c),a
		ret
.Quig_g9k_ForeBack_Palette:	db	%0100
.Quig_g9k_VWait
.Quig_g9k_Vwait_1
		ld		bc,CG9K_Status
		in		a,(c)
		and		g9k_STATUS_VR
		jr		nz,Quig_g9k_Vwait_1
.Quig_g9k_Vwait_2
		ld		bc,CG9K_Status
		in		a,(c)
		and		g9k_STATUS_VR
		jr		z,Quig_g9k_Vwait_2		
		ret		
.directstr_1: DW 11: DB "sheet1.qpt",0
.Quig_App_Path
		ld		hl,Quig_CodeEnd
		inc		hl
		ld		de,(Quig_String_Buffer_Pos)
		ld		bc,0
.Quig_App_Path_1		
		ld		a,(hl)
		cp		"."
		jr		z,Quig_App_Path_Found
		ld		(de),a
		cp		"\"
		jr		nz,Quig_App_Path_x
		ld		c,b
.Quig_App_Path_x:
		inc		b
		inc		hl
		inc		de
		jr		Quig_App_Path_1
.Quig_App_Path_Found:
		ld		hl,(Quig_String_Buffer_Pos)
		ld		e,l
		ld		d,h
		ld		b,0
		add		hl,bc
		inc		hl
		xor		a
		ld		(hl),a
		inc		hl
		ld		(Quig_String_Buffer_Pos),hl
		ex		de,hl
		ret
.Quig_Str_Add
		push	hl
		ex		de,hl
		ld		de,(Quig_String_Buffer_Pos)
		xor		a
.Quig_Str_Add_p1		
		cp		(hl)
		ldi
		jr		nz,Quig_Str_Add_p1
		dec		de
		pop		hl
.Quig_Str_Add_p2		
		cp		(hl)
		ldi
		jr		nz,Quig_Str_Add_p2
		ld		hl,(Quig_String_Buffer_Pos)
		ld		(Quig_String_Buffer_Pos),de
		ret
.Quig_LoadPal_Offset:	db	0
.Quig_LoadTile_Offset:	dw	0
.Quig_LoadTile_Handle:	db	0
.Quig_LoadTile_Count:	db	0
.Quig_LoadTile_Buffer:	dw	0
.Quig_G9K_TileALoad:
		pop		iy
		ld		a,l
		ld		(Quig_LoadTile_Offset),de
		jr		Quig_G9K_TileLoadX
.Quig_G9K_TileBLoad:
		pop		iy
		ld		a,l
		ld		hl,8192
		add		hl,de
		ld		(Quig_LoadTile_Offset),hl		
.Quig_G9K_TileLoadX:
		ld		l,a
		ld		h,0
		ld		c,l
		ld		b,h
		add		hl,hl		;*32
		add		hl,bc		;*48
		ld		bc,Quig_g9k_Ink_Data
		add		hl,bc	
		ld		(Quig_g9k_TileStuff),hl
		pop		hl								;Get File address
		push	iy
		ld		a,(appBnkNum)					;Filename Bank
		db		#DD,#67
		call 	SySystem_CallFunction
        db 		MSC_SYS_SYSFIL
        db 		FNC_FIL_FILOPN					;Open File		
		jp		c,Quig_G9K_TileLoadFail
		ld		(Quig_LoadTile_Handle),a		;Store our File Handle Number	
		ld		a,(appBnkNum)
		ld		e,a
		ld		hl,(Quig_String_Buffer_Pos)
		ld		bc,60							;Header,Tile Cuunt & 16 Palettes
		ld		a,(Quig_LoadTile_Handle)		
		call 	SySystem_CallFunction
		db 		MSC_SYS_SYSFIL
        db 		FNC_FIL_FILINP	
		ld		hl,(Quig_String_Buffer_Pos)
		ld		a,(hl)		
		cp		178
		jp		nz,Quig_G9K_TileLoadFail_Close
		inc		hl
		ld		a,(hl)
		ld		(Quig_LoadTile_Count),a
		inc		hl
		inc		hl
		ld		de,(Quig_g9k_TileStuff)
		ld		bc,48
		ldir
.Quig_LoadTileLoop_1		
		ld		a,(appBnkNum)
		ld		e,a
		ld		hl,(Quig_String_Buffer_Pos)
		ld		(Quig_LoadTile_Buffer),hl		
		ld		bc,2048							;1024 Bytes of tile data
		ld		a,(Quig_LoadTile_Handle)		
		call 	SySystem_CallFunction
		db 		MSC_SYS_SYSFIL
        db 		FNC_FIL_FILINP
		ld		hl,(Quig_LoadTile_Offset)
		ld		a,h
		rra		
		rra	
		rra
		and		%111
		ld		e,a
		add		hl,hl							;*2
		add		hl,hl							;*4
		add		hl,hl							;*8
		add		hl,hl							;*16
		add		hl,hl							;*32
		ld		b,16
.fajeee		
		push	bc
		push	de
		push	hl
		ld		a,g9k_WRITE_ADDR
		ld		bc,CG9K_REG_SELECT
		di
		out		(c),a
		ld		bc,CG9K_REG_DATA
		out		(c),l
		out		(c),h
		out		(c),e
		ld		hl,(Quig_LoadTile_Buffer)
		ld		bc,CG9k_VRAM
		call	Quig_g9k_32outi
		call	Quig_g9k_32outi
		call	Quig_g9k_32outi	
		call	Quig_g9k_32outi		
		ei
		ld		(Quig_LoadTile_Buffer),hl
		pop		hl
		ld		de,128
		add		hl,de
		pop		de
		pop		bc
		djnz	fajeee
		ld		hl,(Quig_LoadTile_Offset)		
		ld		de,64
		add		hl,de
		ld		(Quig_LoadTile_Offset),hl
		ld		a,(Quig_LoadTile_Count)
		dec		a
		ld		(Quig_LoadTile_Count),a
		jr		nz,Quig_LoadTileLoop_1
.Quig_G9K_TileLoadFail_Close:		
		ld		a,(Quig_LoadTile_Handle)
		call 	SySystem_CallFunction
        db 		MSC_SYS_SYSFIL
        db 		FNC_FIL_FILCLO		
.Quig_G9K_TileLoadFail:
		ld		hl,0
		ret		
.Quig_g9k_TileStuff:Dw	0			
.Quig_G9k_Meta_Int_Set:		
		ex		de,hl
		ld		a,g9k_WRITE_ADDR
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		bc,CG9K_REG_DATA
		out		(c),l
		out		(c),h
		ld		a,6
		out		(c),a
		ld		bc,CG9k_VRAM		
		ex		de,hl
		out		(c),l
		out		(c),h
		ret
.Quig_g9k_MapA_Meta:
		pop		iy
		ld		a,g9k_READ_ADDR
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		bc,CG9K_REG_DATA
		out		(c),l
		out		(c),h
		ld		a,6
		out		(c),a
		ld		hl,Quig_g9k_MetaTile_Data
		ld		bc,CG9K_VRAM
		ini		:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b
		ini		:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b
		ini		:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b
		ini		:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b:ini:inc b
		ex		de,hl
		pop		de
		ld		a,l
		and		%1111
		add		96      ;112 Draw to Map B
		ld		h,a
		ld		a,e
		rla		
		rla
		and		%111100
		ld		l,a
		add		hl,hl			;hl=hl*2 (or 32)
		ld		de,Quig_g9k_MetaTile_Data
		call	Quig_g9k_MapA_Meta_Loop
		call	Quig_g9k_MapA_Meta_Loop
		call	Quig_g9k_MapA_Meta_Loop
		call	Quig_g9k_MapA_Meta_Loop
		jp		(iy)
.Quig_g9k_MapA_Meta_Loop
		ld		a,g9k_WRITE_ADDR
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		bc,CG9K_REG_DATA
		out		(c),l
		out		(c),h
		ld		a,7
		out		(c),a
		ld		bc,CG9k_VRAM
		ex		de,hl
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi	
		ex		de,hl
		ld		bc,128
		add		hl,bc
		ret
.Quig_g9k_Meta2MapA_Reg:	dw	0			
.Quig_g9k_MetaTile_Data:
		dw		10,11,12,13,10,15,16,13,10,29,20,21,34,22,22,22,0,0,0,0,0,0,0,0		
.Quig_Shr5:	
		ld a,l:srl h:rra:srl h:rra:srl h:rra:srl h:rra:srl h:rra:ld l,a	
		ret
.Quig_G9K_SCROLL_A	
		ld		a,g9k_SCROLL_LOW_Y
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		a,l
		ld		bc,CG9K_REG_DATA
		out		(c),a		
		ld		a,2
		rrca
		rrca
		or		h
		out		(c),a
		ex		de,hl
		ld		a,g9k_SCROLL_LOW_X
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		a,l
		and		7
		ld		bc,CG9K_REG_DATA
		out		(c),a
		ld		a,l
		srl		h
		rra
		srl		h
		rra		
		srl		h
		rra
		out		(c),a
		ret
.Quig_Mouse_Key:
		rst 	#20
		dw 		#813F
		ld		l,a
		ld		h,0
		ret		
.Quig_Min_Int:
		ld		(Quig_Max_HL),de
		ld		(Quig_Max_DE),hl
		ex		de,hl
		jr		Quig_Max_Int2
.Quig_Max_Int:
		ld		(Quig_Max_HL),de
		ld		(Quig_Max_DE),hl
.Quig_Max_Int2:		
		ld 		a,h
        xor		d
		jp 		m,quig_Max_te2
		sbc 	hl,de
		jr 		z,quig_Max_te1
		jr 		nc,quig_Max_te3
		ld 		hl,(Quig_Max_HL)
		ret
.Quig_Max_te1                 ;false
		ld 		hl,(Quig_Max_HL)
		ret
.Quig_Max_te2 
		bit 	7,d
		jr 		z,Quig_Max_te1
.Quig_Max_te3                ;true
        ld 		hl,(Quig_Max_DE)
        ret
.Quig_Max_HL:dw 0
.Quig_Max_DE:dw	0		
.Quig_GTE_HL
		ld		a,h
        xor		d
        jp 		m,quig_cmpgte2
        ex 		de,hl
        sbc 	hl,de
        jr 		nc,quig_cmpgte3
.quig_cmpgte1               ;false
        ld 		hl,0
        ret
.quig_cmpgte2 
		bit 	7,d
        jr 		nz,quig_cmpgte1
.quig_cmpgte3              ;true
        ld 		hl,1
        ret
.Quig_GT_HL
		ld 		a,h
        xor 	d
        jp 		m,quig_cmpgte2
        sbc 	hl,de
        jr 		c,quig_cmpgte3
        ld 		hl,0
        ret	
.Quig_GTE_HL_Direct
		ld		a,h
        xor		d
        jp 		m,quig_cmpgte2dx
        ex 		de,hl
        sbc 	hl,de
        jr 		nc,quig_cmpgte3dx
.quig_cmpgte1dx               ;false
        xor		a
        ret
.quig_cmpgte2dx 
		bit 	7,d
        jr 		nz,quig_cmpgte1dx
.quig_cmpgte3dx              ;true
        ld 		a,1
		or		a
        ret
.Quig_GT_HL_Direct
		ld 		a,h
        xor 	d
        jp 		m,quig_cmpgte2dx
        sbc 	hl,de
        jr 		c,quig_cmpgte3dx
        xor 	a
        ret			
.Quig_Mul16
		ld		c,l
		ld		a,h
		ld 		b,16
.Quig_INT_Mult16_Loop_DEHL:
		add		hl,hl
		sla 	c
		rla
		jr 		nc,Quig_INT_Mult16_NoAdd_DEHL
		add 	hl,de
.Quig_INT_Mult16_NoAdd_DEHL:
		djnz	Quig_INT_Mult16_Loop_DEHL
		ret	
.Quig_IRandomize:
		ld		(Quig_RNDSeed),hl
		ret
.Quig_IRnd:
		push	hl
		ld		de,(Quig_RNDSeed)	; Seed is usually 0
		ld		a,d
		ld		h,e
		ld		l,253
		or		a
		sbc		hl,de
		sbc		a,0
		sbc		hl,de
		ld		d,0
		sbc		a,d
		ld		e,a
		sbc		hl,de
		jr		nc,Quig_IRnd2	
		inc		hl
.Quig_IRnd2	
		ld		(Quig_RNDSeed),hl
		ex		de,hl
		pop		hl
		call	Quig_Div16
		ex		de,hl
		ret
.Quig_RNDSeed:dw	100
.Quig_g9k_BackColour_Set:
		ld		a,CG9K_BACK_DROP_COLOR
		ld		bc,CG9K_REG_SELECT
		out		(c),a
		ld		a,l
		and		63
		ld		bc,CG9K_REG_DATA
		out		(c),a
		ret		
.SyDesktop_SendMessage:
        ld 		iy,AppMsgB
        ld 		(iy+0),c
        ld 		(iy+1),a
        ld 		(iy+2),e
        ld 		(iy+3),d
        ld 		(iy+4),l
        ld 		(iy+5),h
        db 		#dd:ld h,2       ;2 is the number of the desktop manager process
        ld 		a,(AppPrzN)
        db 		#dd:ld l,a
        rst 	#10
        ret
.SyDesktop_WaitMessage: 
		ld 		iy,AppMsgB
.SyDWMs1:
		db 		#dd:ld h,2       ;2 is the number of the desktop manager process
        ld 		a,(AppPrzN)
        db 		#dd:ld l,a
        rst 	#08             ;wait for a desktop manager message
        db 		#dd:dec l
        jr 		nz,SyDWMs1
        ld 		a,(iy+0)
        ret
.Quig_g9k_Ink_Set:
		pop		iy
		ld		a,l
		call	Quig_g9k_Max32
		ld		a,b
		ld		(Quig_g9k_Ink_Set_x9+1),a
		ld		a,e
		call	Quig_g9k_Max32
		ld		a,b		
		ld		(Quig_g9k_Ink_Set_x8+1),a		
		pop		de
		ld		a,e
		call	Quig_g9k_Max32
		ld		a,b
		ld		(Quig_g9k_Ink_Set_x7+1),a	
		pop		hl
		ld		e,l
		ld		d,h
		add		hl,hl
		add		hl,de
		ld		de,Quig_g9k_Ink_Data
		add		hl,de
.Quig_g9k_Ink_Set_x7:			;Red			
		ld		a,0
		ld		(hl),a
		inc		hl
.Quig_g9k_Ink_Set_x8:			;Green				
		ld		a,0
		ld		(hl),a
		inc		hl		
.Quig_g9k_Ink_Set_x9:			;Blue				
		ld		a,0
		ld		(hl),a
		inc		hl
		jp		(iy)
.Quig_g9k_Max32:
		ld		b,a
		and		%11100000
		ret		z
		and		%10000000
		jr		z,Quig_g9k_Max32_1
		ld		b,0
		ret
.Quig_g9k_Max32_1		
		ld		b,31
		ret
.Quig_g9k_Ink_Data
	ds	256*3
.Quig_g9k_32outi:
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		inc 	b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi:inc b:outi
		ret		
.Quig_Mod16:
		call	Quig_Div16
		ex		de,hl
		ret
.Quig_Div16:
		ex		de,hl           	; HL = DE \ HL
		ld		a,e             	; Division by zero?
		Or		d
		jr		nz,Quig_N_Div17      ; Continue of not
		ld		hl,0
		ld		de,0
		scf			            	; Set Carry to indicate an error
		ret
.Quig_N_Div17:
		ld		c,l             	; AC = HL
		ld		a,h
		ld		hl,0            	; HL = Modulus
		ld		b,16            	; 16-bit division
		Or		a               	; Start with carry reset
.Quig_N_Div18:
		rl		c               	; AC = AC * 2
		rla  	                	; (set Carry to bit 0)
		rl		l               	; HL = HL * 2
		rl		h               	; (reset Carry again (HL = 0))
		push	hl
		sbc		hl,de
		ccf                     	; Carry set when Ok
		jr		c,Quig_N_Div19       ; Modulus cannot be >= Value
		ex		(sp),hl         	; Restore Modulus
.Quig_N_Div19:
		inc		SP              	; Get Modulus from Stack
		inc		SP
		djnz 	Quig_N_Div18         ; Repeat for all bits
		ex		de,hl           	; DE = Modulus
		rl		c               	; Carry to C
		ld		l,c             	; HL = AC
		rla
		ld		h,a
		Or		a               	; Reset Carry (valid result)
		ret		
.Quig_CodeEnd:db 0
.AppDatBeg
.AppFormStart:    dw Form1_Begin
.AppFormLists
    dw Form1_ControlWindowData
.Icon24_Data
.Icon24_Data_WidthByte:     db 12
.Icon24_Data_WidthPixel:    db 24
.Icon24_Data_Height:        db 24
.Icon24_Data_DataAddr:      dw Icon24_Data_Data
.Icon24_Data_EncodeAddr:    dw Icon24_Data_Encode
.Icon24_Data_Size:          dw 288
.Icon24_Data_Encode:        db 5
.Icon24_Data_Data:          
             db 51,51,51,51,51,51,51,51,51,51,51,51
             db 48,0,0,0,0,0,0,0,0,0,0,3
             db 48,0,0,0,0,1,17,16,0,0,0,3
             db 48,0,0,1,17,18,34,33,16,0,0,3
             db 48,0,0,18,34,34,34,34,33,16,0,3
             db 48,0,1,34,34,34,34,34,34,33,0,3
             db 48,0,18,34,34,33,18,34,34,33,0,3
             db 48,0,18,34,34,16,1,34,34,33,0,3
             db 48,1,34,34,33,0,0,18,34,33,0,3
             db 48,1,34,34,33,0,0,18,34,33,0,3
             db 48,1,34,34,33,0,0,18,34,33,0,3
             db 48,1,34,34,33,0,1,34,34,16,0,3
             db 48,1,34,34,34,17,18,34,34,16,0,3
             db 48,1,34,34,34,34,34,34,33,0,0,3
             db 48,0,18,34,34,34,34,34,17,0,0,3
             db 48,0,1,34,34,34,34,33,0,0,0,3
             db 48,0,0,17,17,34,34,34,16,0,0,3
             db 48,0,0,0,0,18,34,34,33,17,16,3
             db 48,0,0,0,0,1,34,34,34,34,16,3
             db 48,0,0,0,0,0,18,34,34,34,16,3
             db 48,0,0,0,0,0,1,34,34,34,16,3
             db 48,0,0,0,0,0,0,17,17,17,16,3
             db 48,0,0,0,0,0,0,0,0,0,0,3
             db 51,51,51,51,51,51,51,51,51,51,51,51
.Sheet_Data4:                   
.Sheet_Data4_WidthByte:     db 2
.Sheet_Data4_WidthPixel:    db 1
.Sheet_Data4_Height:        db 1
.Sheet_Data4_DataAddr:      dw Sheet_Data4_Data
.Sheet_Data4_EncodeAddr:    dw Sheet_Data4_Encode
.Sheet_Data4_Size:          dw 1
.Sheet_Data4_Encode:        db 0
.Sheet_Data4_Data:          dw 0
.File_Select_Text:   dw File_Select_Text_Data+4
.Directory_Select_Text:   dw Directory_Select_Text_Data+4
.var_byt_mySheet_status:   db 0
.var_byt_mySheet_sheet:   db 0
.var_byt_mySheet_tiles:   db 0
.var_wrd_mySheet_size:   dw 0
.var_byt_mySheet_bank:   db 0
.var_wrd_mySheet_addr:   dw 0
.var_byt_mySheet_colourdepth:   db 0
.var_wrd_pattCount:   dw 0
.var_byt_f:   db 0
.var_byt_g:   db 0
.var_wrd_scrollx:   dw 0
.var_wrd_scrollxlast:   dw 0
.var_wrd_scrollxnow:   dw 0
.Quigs_String_Data_Start:
.File_Select_Text_Data:         dw File_Select_Text:dw 1:db 0
.Directory_Select_Text_Data:    dw Directory_Select_Text:dw 1:db 0
.Quig_Dialog_1_Data:            dw Quig_Dialog_1:dw 1:db 0
.Quig_Dialog_2_Data:            dw Quig_Dialog_2:dw 1:db 0
.Quig_Dialog_3_Data:            dw Quig_Dialog_3:dw 1:db 0
.Form1_Text_Data:               dw Form1_Text:dw 7:db "Form 1",0
.Form1_Status_Text_Data:        dw Form1_Status_Text:dw 1:db 0
.Quig_String_Count   Equ 7
.Quig_String_End_Text:   db  0,0,0,0,0
.AppTrnBeg
          ds    256
.AppStk   ds    6*2
          dw    AppPrz
.AppPrzN  db    0
.AppMsgB
.Event_Message       db 0         ;0 Message No 16
.Event_Form_ID       db 0         ;1 Event happned on which Form
.Event_Type          db 0         ;2 Type of Event
.Event_UserInput     db 0         ;3 Key or Mouse Event
.Event_Key_ASCII                  ; Key ASCII - Shared Byte with next
.Event_MouseX        dw 0         ;4 MouseX when event happens
.Event_MouseY        dw 0         ;6 MouseY when event happens
.Event_Control_ID    dw 0         ;8 Control ID No
.Event_8             db 0         ;10
.Event_9             db 0         ;11
.Event_10            db 0         ;12
.Event_11            db 0         ;13
.Quig_Machine_Type   db 0    ;0=464, 1=664, 2=6128, 3=464Plus, 4=6128Plus 6=Enterprise 64/128 7=MSX1 8=MSX2, 9=MSX2+, 10=MSX TurboR 12=PCW8xxx, 13=PCW9xxx
.Quig_Null_String    db 0
.Quig_Dialog_1:      dw Quig_Dialog_1_Data+4,6
.Quig_Dialog_2:      dw Quig_Dialog_2_Data+4,6
.Quig_Dialog_3:      dw Quig_Dialog_3_Data+4,6
.Quig_Dialog_4:      dw AppIcnLrg
.App_Form_List
       dw  Form1_Begin,0,0,0,0,0,0,Form1
.ControWindowDataList
     dw Form1_ControlWindowData
     dw Form1_ControlToolData
.Form1
.Form1_Addr:                    db 0,0
.Form1_Begin:                   
.Form1_Status:                  db 1
.Form1_Display:                 db 92
.Form1_SizeAdjust:              db 20
.Form1_OwnerID:                 db 0
.Form1_Left:                    dw 0
.Form1_Top:                     dw 0
.Form1_Width:                   dw 200
.Form1_Height:                  dw 122
.Form1_OffsetWidth:             dw 1
.Form1_OffsetHeight:            dw 8
.Form1_ContentWidth:            dw 191
.Form1_ContentHeight:           dw 122
.Form1_MinWidth:                dw 0
.Form1_MinHeight:               dw 0
.Form1_MaxWidth:                dw 1024
.Form1_MaxHeight:               dw 212
.Form1_IconAddr:                dw 0
.Form1_Text:                    dw Form1_Text_Data+4
.Form1_Status_Text:             dw Form1_Status_Text_Data+4
.Form1_MenuAddr:                dw Form1_Menu
.Form1_ControlWindowAddr:       dw Form1_ControlWindow
.Form1_ControlToolAddr:         dw Form1_ControlTool
.Form1_ToolBarHeight:           dw 8
     db 0,0,0,0,0,0,0,0,0       ;Symbos Reserved
.Form1_SuperWindow:             db  0
     ds 140,0                   ;Symbos Reserved
.Form1_Menu_List:               
.Form1_Menu:                    
        dw  0
.Form1_ControlWindow:           
.Form1_ControlWindowCount:      db 1
.Form1_ControlWindowOwnerID:    db 0
.Form1_ControlWindowDataAddr:   dw Form1_ControlWindowData
.Form1_ControlWindowCalcAddr:   dw 0; Form1_ControlWindowCalc
     db 0,0,0,0,0,0,0,0
.Form1_ControlWindowFocus:      db 0
     db 0
.Form1_ControlWindowData:       
dw 0,255*256+0,2,  0,0,1000,1000,0
.Form1_ControlTool:             
.Form1_ControlToolCount:        db 1
.Form1_ControlToolOwnerID:      db 0
.Form1_ControlToolDataAddr:     dw Form1_ControlToolData
.Form1_ControlToolCalcAddr:     dw 0; Form1_ControlToolCalc
     db 0,0,0,0,0,0,0,0
.Form1_ControlToolFocus:        db 0
     db 0
.Form1_ControlToolData:         
dw 0,255*256+0,2,  0,0,1000,1000,0
.SyStud_TimerRoutines    dw 0
.Quig_File_Select_Ext          ds 4
.Quig_File_Select_File         ds 256
.AppTrnEnd
